[{
  Name: "Buienradar",
  Author: "Marcel van den Arend",
  Version: "2015-06-4",

  GroupName: '',
  IconImage: 'pages/control/widgets/Arend/buienradar/buienradar.png',
  StatusText: '',
  Description: '',
  Initialized: false,

  RenderView: function (cuid, module) {
    var container = $(cuid);
    var widget = container.find('[data-ui-field=widget]');
    var controlpopup = widget.data('ControlPopUp');
    var popupisopen = false;
    
    if (!controlpopup)
    {
      container.find('[data-ui-field=controlpopup]').trigger('create');
      controlpopup = container.find('[data-ui-field=controlpopup]').popup();
      widget.data('ControlPopUp',  controlpopup);
      //

      // when widget is clicked control popup is shown
      widget.on('click', function() {
        if ($(cuid).find('[data-ui-field=widget]').data('ControlPopUp'))
        {
                    var popup = $(cuid).find('[data-ui-field=widget]').data('ControlPopUp');
                    popup.popup('open');
          popup.find('[data-ui-field=buienradarpicture]').attr('src', 'http://www.buienradar.nl/image?type=zozw&' + (new Date().getTime()));
        }
      });

    }
    if (!this.Initialized) {
      this.Initialized = true;
      //
      // ui events handlers
      //
      // settings button
      widget.find('[data-ui-field=settings]').on('click', function () {
        HG.WebApp.Control.EditModule(module);
      });
    };

    widget.find('[data-ui-field=name]').html(module.Name);
    //
    var sensoricon = '';
    var sensorimgdata = '';
    var sensortxtdata = '';
    var infotext = '';
    var lastupdatetime = 0;
    var timeDisplay = '';
    var rainDisplay = '';
    var NoRainDisplay = '';
    var maxRainInfo = '';    
    if(module.Properties != null) {
      // For align the graph and the sign text (-)
      rainDisplay += "<div class='Low' style='padding-top: 7px;width: 0px'></div>";
      //
      for (p = 0; p < module.Properties.length; p++) {
        if (module.Properties[p].Name.indexOf('Buienradar.') == 0){

          var propValue = Math.round(module.Properties[p].Value.replace(',', '.') * 10) / 10;
          if (isNaN(propValue)) propValue = module.Properties[p].Value;         

          if (module.Properties[p].Name == 'Buienradar.RawData') {
            var maxValue = 0;
            var lines = propValue.split(';');
            // create the graph
            for (x = 0; x < lines.length; x++) {
              var data = lines[x].split('|');
              var theTime = data[1];
              if( theTime.indexOf(':00') > 0 || theTime.indexOf(':30') > 0)
              { timeDisplay += "<p>" + data[1] + "&nbsp;-</p>";}

              var theRain = data[0].replace(',', '.');
              var theClass = "";
              var theWidth = 0;
              if (theRain < 1) {
                theClass = "Low";
                theWidth = Math.round(theRain * 25);
              }
              if (theRain >= 1) {
                theClass = "Medium";
                // Max value 75
                theWidth = Math.round(theRain * 25);
              } 
              if (theRain > 3) {
                theClass = "High";
                // Max value 75 + 49 = 124
                theWidth = Math.round((theRain - 3) * 7) + 75;
              }
              if (theRain > 10) {
                theClass = "VeryHigh";
                // Max value 75 + 49 + 60 = 184
                 theWidth = Math.round((theRain - 10) * 3) + 75 + 49;
              }
              if (theRain > 30) {
                theClass = "Extreme";
                theWidth = Math.round((theRain - 30) * 1) + 75 + 49 + 60;
              }
              rainDisplay += "<div class='" + theClass + "' style=' width:" + theWidth + "px;' title='" + theTime + " - " + theRain + " mm'></div>"
            }
          }

          if (module.Properties[p].Name == 'Buienradar.MaxRainExpected') { 
            if (propValue > 0)
            {
              maxRainInfo =  "<div class='Legend'><div class='Low'></div>< 1";
              maxRainInfo +=  "<div class='Medium'></div>1+";
              maxRainInfo +=  "<div class='High'></div>3+";
              maxRainInfo +=  "<div class='VeryHigh'></div>10+";
              maxRainInfo +=  "<div class='Extreme'></div>30+ mm/hour</div>";
              maxRainInfo += "<p>Maximum " + propValue + " mm/hour expected</p>";
            }
            else
            {
              NoRainDisplay = "<p style='padding-top: 20px; text-align: center;'>No rain expected.</p>";
            }
          }

          var updatetime = module.Properties[p].UpdateTime;
          if (typeof(updatetime) != 'undefined')
          {
            updatetime = updatetime.replace(' ', 'T'); // fix for IE and FF
            var d = new Date(updatetime);
            if (lastupdatetime < d) {
              lastupdatetime = d;
            }
          }
        }
      }
    }
    //
    widget.find('[data-ui-field=description]').html((module.Domain.substring(module.Domain.lastIndexOf('.') + 1))+' '+module.Address);
    //
    if (lastupdatetime > 0) {
      this.UpdateTime = HG.WebApp.Utility.FormatDate(lastupdatetime) + ' ' + HG.WebApp.Utility.FormatDateTime(lastupdatetime);
      widget.find('[data-ui-field=status]').html('<span style="vertical-align:middle;font-size:13px">' + this.UpdateTime + '</span>&nbsp;&nbsp;' + infotext);
      widget.find('[data-ui-field=times]').html(timeDisplay);
      if (NoRainDisplay.length > 0)
      {
        rainDisplay = NoRainDisplay;
      }
      widget.find('[data-ui-field=rain]').html(rainDisplay);
      widget.find('[data-ui-field=info]').html(maxRainInfo);
    }
  }
}]